#ifndef _VX_LIMIT_DEF_H
#define _VX_LIMIT_DEF_H

#include <asm/atomic.h>
#include <asm/resource.h>

#include "limit.h"

/* context sub struct */

struct _vx_limit {
	atomic_t ticks;

	unsigned long rlim[NUM_LIMITS];		/* Context limit */
	unsigned long rmax[NUM_LIMITS];		/* Context maximum */
	atomic_t rcur[NUM_LIMITS];		/* Current value */
	atomic_t lhit[NUM_LIMITS];		/* Limit hits */
};


#ifdef	_VX_INFO_INIT_

static inline void vx_info_init_limit(struct _vx_limit *limit)
{
	int lim;

	for (lim=0; lim<NUM_LIMITS; lim++) {
		limit->rlim[lim] = RLIM_INFINITY;
		limit->rmax[lim] = 0;
		atomic_set(&limit->rcur[lim], 0);
		atomic_set(&limit->lhit[lim], 0);
	}
}

static inline void vx_info_exit_limit(struct _vx_limit *limit)
{
#ifdef	CONFIG_VSERVER_DEBUG
	unsigned long value;
	unsigned int lim;

	for (lim=0; lim<NUM_LIMITS; lim++) {
		value = atomic_read(&limit->rcur[lim]);
		if (value)
			printk("!!! limit: %p[%s,%d] = %ld on exit.\n",
				limit, vlimit_name[lim], lim, value);
	}
#endif
}

#endif	/* _VX_INFO_INIT_ */
#endif	/* _VX_LIMIT_DEF_H */
