#ifndef _VX_NGNET_DEF_H
#define _VX_NGNET_DEF_H

#include <asm/atomic.h>
#include <asm/resource.h>

#include "ngnet.h"

/* context sub struct */

struct _vx_ngnet {
	struct net_device *dev_base;
	struct net_device **dev_tail;

	struct _vx_dev_hash {
		struct hlist_head name;
		struct hlist_head index;
	} dev_hash[1 << NG_HASHBITS];

};


#ifdef	_VX_INFO_INIT_

static inline void vx_info_init_ngnet(struct _vx_ngnet *ngnet)
{
	int index;

	ngnet->dev_base = NULL;
	ngnet->dev_tail = &ngnet->dev_base;

	for (index=0; index<(1 << NG_HASHBITS); index++) {
		INIT_HLIST_HEAD(&ngnet->dev_hash[index].name);
		INIT_HLIST_HEAD(&ngnet->dev_hash[index].index);
	}
}

static inline void vx_info_exit_ngnet(struct _vx_ngnet *ngnet)
{
	int index;

	for (index=0; index<(1 << NG_HASHBITS); index++) {
		// get rid of devices ...
	}
}

#endif	/* _VX_INFO_INIT_ */
#endif	/* _VX_NGNET_DEF_H */
