
/*
** Copyright (C) 2003-2004 Herbert Poetzl
**
** V0.01	test for syscall
**
*/

#define VERSION "V0.01"

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <signal.h>
#include <syscall.h>
#include <asm/unistd.h>
#include <unistd.h>
#include <sched.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/mount.h>

 
#include "vswitch.h"
#undef	ENOTSUP
#include <linux/vserver/switch.h>
#include <linux/vserver/ngnet.h>
#include <linux/vserver/ngnet_cmd.h>


static	char	err_flag = 0;

static	char	opt_vers = 0;
static	char	opt_ngnet = 0;

static	char *	cmd_name = NULL;

static	int 	num_ctx = 0;


#define OPTIONS "+hx:NV"

int	main(int argc, char *argv[])
{
        extern int optind;
        extern char *optarg;
        char c, errflg = 0;
	int r;


        cmd_name = argv[0];
        while ((c = getopt(argc, argv, OPTIONS)) != EOF) {
            switch (c) {
            case 'h':
                fprintf(stderr,
                    "This is %s " VERSION "\n"
                    "options are:\n"
                    "-h        print this help message\n"
                    "-x <num>  context id\n"
                    "-N        create new device\n"
                    "-V        verify interface version\n"
                    "--        end of options\n"
                    ,cmd_name);
                exit(0);
                break;
            case 'x':
                num_ctx = atol(optarg);
                break;
            case 'N':
                opt_ngnet = 1;
                break;
            case 'V':
                opt_vers = 1;
                break;
            case '?':
            default:
                errflg++;
                break;
            }
        }
        if (errflg) {
            fprintf(stderr, 
                "Usage: %s -[" OPTIONS "]\n"
                "%s -h for help.\n",
                cmd_name, cmd_name);
            exit(2);
        }

	if (opt_vers) {
	    r = vserver(VCMD_get_version, 0, NULL);
	    if (r<0)
	    	perror("vc_get_version");
    	    else 
	    	printf("version: %04x:%04x\n", 
		    (r>>16)&0xFFFF, r&0xFFFF);
	}

	if (opt_ngnet) {
	    r = vserver(VCMD_ngn_new_dev, num_ctx, NULL);
	    if (r)
	    	perror("vc_ngn_new_dev");
	}
	
	exit((err_flag)?1:0);
}

